<?php
/**
 * Pet Bazaar Theme Customizer.
 *
 * @package Pet Bazaar 
 */

 if ( ! class_exists( 'Pet_Bazaar_Customizer' ) ) {

	/**
	 * Customizer Loader
	 *
	 * @since 1.0.0
	 */
	class Pet_Bazaar_Customizer {

		/**
		 * Instance
		 *
		 * @access private
		 * @var object
		 */
		private static $instance;

		/**
		 * Initiator
		 */
		public static function get_instance() {
			if ( ! isset( self::$instance ) ) {
				self::$instance = new self;
			}
			return self::$instance;
		}

		/**
		 * Constructor
		 */
		public function __construct() {
			/**
			 * Customizer
			 */
			add_action( 'admin_enqueue_scripts',array( $this, 'pet_bazaar_admin_script' ) ); 
			add_action( 'customize_preview_init',array( $this, 'pet_bazaar_customize_preview_js' ) );
			add_action( 'customize_register',    array( $this, 'pet_bazaar_customizer_register' ) );
			add_action( 'after_setup_theme',     array( $this, 'pet_bazaar_customizer_settings' ) );
		}
		
		/**
		 * Add postMessage support for site title and description for the Theme Customizer.
		 *
		 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
		 */
		function pet_bazaar_customizer_register( $wp_customize ) {
			
			$wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
			$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
			$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
			$wp_customize->get_setting( 'background_color' )->transport = 'postMessage';
			$wp_customize->get_setting('custom_logo')->transport = 'refresh';

			$wp_customize->register_control_type( 'Pet_Bazaar_Control_Sortable' );
			/**
			 * Helper files
			 */
			require PET_BAZAAR_PARENT_INC_DIR . '/customizer/customizer-controls.php';
			require PET_BAZAAR_PARENT_INC_DIR . '/customizer/sanitization.php';
		}
		
		
		/**
		 * Admin Script
		 */
		function pet_bazaar_admin_script() {
			wp_enqueue_style('pet-bazaar-admin-style', get_template_directory_uri() . '/inc/customizer/assets/css/admin.css');
			wp_enqueue_script( 'pet-bazaar-admin-script', PET_BAZAAR_PARENT_INC_URI . '/customizer/assets/js/admin-script.js', array( 'jquery' ), '', true );
			wp_enqueue_script( 'pet-bazaar-customizer-section-script', PET_BAZAAR_PARENT_INC_URI . '/customizer/assets/js/customizer-section.js', array( 'jquery' ), '', true );
			wp_localize_script( 'pet-bazaar-admin-script', 'pet_bazaar_ajax_object',
				array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
			);
		}
		
		/**
		 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
		 */
		function pet_bazaar_customize_preview_js() {
			wp_enqueue_script( 'pet-bazaar-customizer', PET_BAZAAR_PARENT_INC_URI . '/customizer/assets/js/customizer-preview.js', array( 'customize-preview' ), '20151215', true );
		}

		// Include customizer customizer settings.
			
		function pet_bazaar_customizer_settings() {
			require PET_BAZAAR_PARENT_INC_DIR . '/customizer/customizer-options/pet-bazaar-header.php';
			require PET_BAZAAR_PARENT_INC_DIR . '/customizer/customizer-options/pet-bazaar-footer.php';
			require PET_BAZAAR_PARENT_INC_DIR . '/customizer/customizer-options/pet-bazaar-blog.php';
			require PET_BAZAAR_PARENT_INC_DIR . '/customizer/customizer-options/pet-bazaar-general.php';
			require PET_BAZAAR_PARENT_INC_DIR . '/customizer/customizer-options/pet_bazaar_recommended_plugin.php';
			require PET_BAZAAR_PARENT_INC_DIR . '/customizer/customizer-options/pet-bazaar-pro.php';
		}

	}
}// End if().

/**
 *  Kicking this off by calling 'get_instance()' method
 */
Pet_Bazaar_Customizer::get_instance();